<template>
  <div class="clock">
    <button @click="handleLogOut()" class="x x-fixed-2">log-out</button>
    <!-- <log-out-btn>halo</log-out-btn> -->
    <base-card>
      <h1>Taki o zegareczek</h1>
      <p>Proszę się uczyć!</p>
      <div class="btns">
        <button @click="startLearning">Start Learning</button>
        <button @click="takeABreak">Take a break</button>
        <button @click="stopAll">Stop all</button>
        <button @click="resetTimers">Reset clocks</button>
      </div>

      <h2>
        <!-- Learning time: <span>{{ (learningTime / 100).toFixed(2) }}</span> -->
        Learning time:
        <span
          >hours: {{ learningHours }} minutes: {{ learningMinutes }} seconds:
          {{ (learningTime / 100).toFixed(2) }}</span
        >
      </h2>
      <h2>
        Break time:
        <span
          >hours: {{ breakHours }} minutes: {{ breakMinutes }} seconds:
          {{ (breakTime / 100).toFixed(2) }}</span
        >
      </h2>
    </base-card>
  </div>
</template>

<script>
import * as Keycloak from "keycloak-js";

export default {
  mounted() {
    this.login();
  },
  data() {
    return {
      learningTime: 0,
      learningMinutes: 0,
      learningHours: 0,
      breakTime: 0,
      breakMinutes: 0,
      breakHours: 0,
      idStartInterval: undefined,
      idTakeABreakInterval: undefined,
      startActive: false,
      breakActive: false,
    };
  },

  methods: {
    startLearning() {
      if (!this.startActive) {
        clearInterval(this.idTakeABreakInterval);
        this.idStartInterval = setInterval(() => {
          this.learningTime++;
          // this.increaseTime(
          //   this.learningTime,
          //   this.learningMinutes,
          //   this.learningHours
          // );
          if (this.learningTime >= 6000) {
            this.learningMinutes++;
            this.learningTime = 0;
          }
          if (this.learningMinutes >= 60) {
            this.learningHours++;
            this.learningMinutes = 0;
          }
        }, 10);
        this.startActive = true;
        this.breakActive = false;
      }
    },
    takeABreak() {
      if (!this.breakActive) {
        clearInterval(this.idStartInterval);
        this.idTakeABreakInterval = setInterval(() => {
          this.breakTime++;
          if (this.breakTime >= 6000) {
            this.breakMinutes++;
            this.breakTime = 0;
          }
          if (this.breakMinutes >= 60) {
            this.breakHours++;
            this.breakMinutes = 0;
          }
        }, 10);
        this.breakActive = true;
        this.startActive = false;
      }
    },
    stopAll() {
      clearInterval(this.idTakeABreakInterval);
      clearInterval(this.idStartInterval);
      this.breakActive = false;
      this.startActive = false;
    },
    resetTimers() {
      this.stopAll();
      this.learningTime = 0;
      this.learningMinutes = 0;
      this.learningHours = 0;
      this.breakTime = 0;
      this.breakMinutes = 0;
      this.breakHours = 0;
      this.breakActive = false;
      this.startActive = false;
    },

    increaseTime(time, minutes, hours) {
      if (time >= 2) {
        time = 0;
        minutes++;
      }
      if (minutes >= 60) {
        minutes = 0;
        hours++;
      }
      console.log(
        "time: ",
        time / 10,
        "\n minutes: ",
        minutes,
        "\n hours: ",
        hours
      );
      // break;
    },

    // do keycloak
    handleLogOut() {
      const MY_REALM = "test";
      const ENCODED_REDIRECT_URI = "https://fantastic-app.mac.pl:8081";
      window.location.replace(
        `${process.env.VUE_APP_BASE_KEYCLOAK_URL}realms/${MY_REALM}/protocol/openid-connect/logout?redirect_uri=${ENCODED_REDIRECT_URI}`
      );
    },
    login() {
      var keycloak = Keycloak({
        realm: `test`,
        url: `${process.env.VUE_APP_BASE_KEYCLOAK_URL}`,
        clientId: `fantastic-app`,
        "ssl-required": "all",
        resource: `fantastic-app`,
        "public-client": true,
        "confidential-port": 0,
      });
      keycloak
        .init({
          // flow: 'implicit',
          promiseType: "native",
          onLoad: "login-required",
        })
        .then((authenticated) => {
          // console.log('TOKEN', this.decodeToken(keycloak.token));
          return authenticated;
        })
        .catch((error) => {
          console.error(error);
        });
      keycloak.onTokenExpired = () => {
        keycloak
          .updateToken(30)
          .then((refreshed) => {
            if (refreshed) {
              console.log(refreshed);
              this.$store.commit("TOKEN_SET", keycloak.token);
            } else {
              console.log("Token is still valid");
            }
          })
          .catch((error) => {
            console.error(error);
          });
      };
    },
  },
  computed: {
    // learningMinutes() {},
  },
};
</script>

<style scoped>
button {
  padding: 0.75rem 1.5rem;
  font-family: inherit;
  background-color: #3a0061;
  border: 1px solid #3a0061;
  color: white;
  cursor: pointer;
  transition: 0.2s;
}

button:hover,
button:active {
  background-color: #270041;
  border-color: #270041;
}
.x {
  margin: 8px;
  padding: 8px;
  cursor: pointer;
  font-weight: bold;
  transition: 0.3s;
  background-color: #edd2ff;
  border: 1px solid #000;
  color: black;
}
.x:hover {
  color: white;
  background-color: #3a0061;
}
.x-fixed-2 {
  position: absolute;
  top: 10px;
  right: 10px;
}
</style>
